diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 9765a92d1..7dbf69160 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -1,17 +1,22 @@
 package net.minecraft.client.render;
 
-import static org.lwjgl.opengl.GL11.*;
-
 import java.util.List;
 import java.util.Random;
 
 import com.mojang.logging.LogUtils;
+import net.minecraft.client.render.culling.CameraFrustum;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.CompareFunc;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.animal.MobPig;
+import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.weather.IPrecipitation;
 import org.jetbrains.annotations.NotNull;
 import org.joml.Matrix4f;
@@ -20,8 +25,6 @@ import org.joml.Vector3dc;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.util.glu.GLU;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.particle.ParticleWaterDrop;
@@ -40,9 +43,8 @@ import net.minecraft.client.render.camera.EntityCameraSleeping;
 import net.minecraft.client.render.camera.EntityCameraThirdPersonFront;
 import net.minecraft.client.render.camera.EntityCameraThirdPersonRear;
 import net.minecraft.client.render.colorizer.Colorizers;
-import net.minecraft.client.render.culling.Frustum;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.util.debug.Debug;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.entity.Entity;
@@ -54,6 +56,7 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.core.world.weather.Weather;
+import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
 public class WorldRenderer {
@@ -61,7 +64,7 @@ public class WorldRenderer {
     public static final long nsPerSecond = 1_000_000_000L;
     public final LightmapHelper lightmapHelper;
     public Minecraft mc;
-    private float farPlaneDistance;
+    public float farPlaneDistance;
     public ItemRenderer itemRenderer;
     public FogManager fogManager;
     private int rendererUpdateCount;
@@ -108,15 +111,14 @@ public class WorldRenderer {
         this.lightmapHelper.tick();
     }
 
-    private float b = 1.0f;
-    private float a = 1.0f;
-    private float currentFovModifier = 1.0f;
+    private float fovMod = 1.0f;
+    private float fovModOld = 1.0f;
 
     private void updateSpeedFov() {
         PlayerLocal player = this.mc.thePlayer;
-        this.currentFovModifier = this.mc.gameSettings.fovModification.value ? player.getFovModifier() : 1f;
-        this.a = this.b;
-        this.b += (this.currentFovModifier - this.b) * 0.5f;
+        float currentFovModifier = this.mc.gameSettings.fovModification.value ? player.getFovModifier() : 1f;
+        this.fovModOld = this.fovMod;
+        this.fovMod += (currentFovModifier - this.fovMod) * 0.5f;
     }
 
     public void getMouseOver(float partialTicks) {
@@ -204,7 +206,7 @@ public class WorldRenderer {
         float fov = 70f;
         if (isModifiedByFOV) {
             fov = (int) (this.mc.activeCamera.getFov() * 100 + 30);
-            fov *= this.a + (this.b - this.a) * partialTick;
+            fov *= org.joml.Math.lerp(this.fovModOld, this.fovMod, partialTick);
         }
         if (this.mc.gameSettings.fovModification.value && CameraUtil.isUnderLiquid(this.mc.activeCamera, this.mc.currentWorld, Materials.WATER, partialTick)) {
             fov = fov - 10;
@@ -216,66 +218,25 @@ public class WorldRenderer {
         return fov + this.fovModifierLast + (this.fovModifier - this.fovModifierLast) * partialTick;
     }
 
-    @Deprecated
-    private void hurtCameraEffect(float partialTick) {
-        if (!(this.mc.activeCamera instanceof EntityCamera entityCamera)) return;
-        Mob mob = entityCamera.mob;
-        float f1 = (float) mob.hurtTime - partialTick;
-        if (mob.getHealth() <= 0) {
-            float f2 = (float) mob.deathTime + partialTick;
-            glRotatef(40F - 8000F / (f2 + 200F), 0.0F, 0.0F, 1.0F);
-        }
-        if (f1 >= 0.0F) {
-            f1 /= mob.maxHurtTime;
-            f1 = MathHelper.sin(f1 * f1 * f1 * f1 * MathHelper.PI);
-            float f3 = mob.attackedAtYaw;
-            glRotatef(-f3, 0.0F, 1.0F, 0.0F);
-            glRotatef(-f1 * 14F, 0.0F, 0.0F, 1.0F);
-            glRotatef(f3, 0.0F, 1.0F, 0.0F);
-        }
-    }
-
     private @NotNull Matrix4f hurtCameraEffect(@NotNull Matrix4f matrix, float partialTick) {
         if (!(this.mc.activeCamera instanceof EntityCamera entityCamera)) return matrix;
         Mob mob = entityCamera.mob;
         float hurtInterp = (float) mob.hurtTime - partialTick;
         if (mob.getHealth() <= 0) {
             float f2 = (float) mob.deathTime + partialTick;
-            matrix.rotate(org.joml.Math.toRadians(40F - 8000F / (f2 + 200F)), 0.0F, 0.0F, 1.0F);
+            matrix.rotateZ(org.joml.Math.toRadians(40F - 8000F / (f2 + 200F)));
         }
         if (hurtInterp >= 0.0F) {
             hurtInterp /= mob.maxHurtTime;
             hurtInterp = MathHelper.sin(hurtInterp * hurtInterp * hurtInterp * hurtInterp * MathHelper.PI);
             float f3 = mob.attackedAtYaw;
-            matrix.rotate(org.joml.Math.toRadians(-f3), 0.0F, 1.0F, 0.0F);
-            matrix.rotate(org.joml.Math.toRadians(-hurtInterp * 14F), 0.0F, 0.0F, 1.0F);
-            matrix.rotate(org.joml.Math.toRadians(f3), 0.0F, 1.0F, 0.0F);
+            matrix.rotateY(org.joml.Math.toRadians(-f3));
+            matrix.rotateZ(org.joml.Math.toRadians(-hurtInterp * 14F));
+            matrix.rotateY(org.joml.Math.toRadians(f3));
         }
         return matrix;
     }
 
-    @Deprecated
-    private void setupViewBobbing(float partialTick, boolean isHand) {
-        if (this.mc.activeCamera instanceof EntityCamera && ((EntityCamera) this.mc.activeCamera).mob instanceof Player player) {
-            float walkDist = -MathHelper.lerp(player.walkDistO, player.walkDist, partialTick);
-            float cameraVel = MathHelper.lerp(player.cameraVelocityOld, player.cameraVelocity, partialTick);
-            float cameraPitch = MathHelper.lerp(player.prevCameraPitch, player.cameraPitch, partialTick);
-            if (isHand && player.vehicle instanceof MobPig) {
-                cameraVel /= 4;
-//                cameraPitch /= 4;
-                walkDist /= 2;
-            }
-            if (player.isSkating) {
-                walkDist *= 0.25f;
-                cameraPitch *= 0.25f;
-            }
-            GL11.glTranslatef(MathHelper.sin(walkDist * MathHelper.PI) * cameraVel * 0.5F, -Math.abs(MathHelper.cos(walkDist * MathHelper.PI) * cameraVel), 0.0F);
-            GL11.glRotatef(MathHelper.sin(walkDist * MathHelper.PI) * cameraVel * 3F, 0.0F, 0.0F, 1.0F);
-            GL11.glRotatef(java.lang.Math.abs(MathHelper.cos(walkDist * MathHelper.PI - 0.2F) * cameraVel) * 5F, 1.0F, 0.0F, 0.0F);
-            GL11.glRotatef(cameraPitch, 1.0F, 0.0F, 0.0F);
-        }
-    }
-
     private @NotNull Matrix4f setupViewBobbing(@NotNull Matrix4f matrix, float partialTick, boolean isHand) {
         if (this.mc.activeCamera instanceof EntityCamera entityCamera && entityCamera.mob instanceof Player player) {
             float walkDist = -MathHelper.lerp(player.walkDistO, player.walkDist, partialTick);
@@ -291,9 +252,9 @@ public class WorldRenderer {
                 cameraPitch *= 0.25f;
             }
             matrix.translate(MathHelper.sin(walkDist * MathHelper.PI) * cameraVel * 0.5F, -Math.abs(MathHelper.cos(walkDist * MathHelper.PI) * cameraVel), 0.0F);
-            matrix.rotate(org.joml.Math.toRadians(MathHelper.sin(walkDist * MathHelper.PI) * cameraVel * 3F), 0.0F, 0.0F, 1.0F);
-            matrix.rotate(org.joml.Math.toRadians(org.joml.Math.abs(MathHelper.cos(walkDist * MathHelper.PI - 0.2F) * cameraVel) * 5F), 1.0F, 0.0F, 0.0F);
-            matrix.rotate(org.joml.Math.toRadians(cameraPitch), 1.0F, 0.0F, 0.0F);
+            matrix.rotateZ(org.joml.Math.toRadians(MathHelper.sin(walkDist * MathHelper.PI) * cameraVel * 3F));
+            matrix.rotateX(org.joml.Math.toRadians(org.joml.Math.abs(MathHelper.cos(walkDist * MathHelper.PI - 0.2F) * cameraVel) * 5F));
+            matrix.rotateX(org.joml.Math.toRadians(cameraPitch));
         }
         return matrix;
     }
@@ -321,74 +282,23 @@ public class WorldRenderer {
 
     }
 
-    @Deprecated
-    private void orientCamera(float partialTick) {
-        setupCamera(partialTick);
-        this.mc.activeCamera.applyGlTransformations();
-
-        if (!(this.mc.currentScreen instanceof ScreenPhotoMode) && !this.mc.gameSettings.lockCamera.value) {
-            glRotatef((float) this.mc.activeCamera.getXRot(partialTick), 1.0F, 0.0F, 0.0F);
-            glRotatef((float) (this.mc.activeCamera.getYRot(partialTick) + 180F), 0.0F, 1.0F, 0.0F);
-        }
-
-        if (this.mc.currentScreen instanceof ScreenPhotoMode) {
-            glRotatef(((ScreenPhotoMode) this.mc.currentScreen).getTilt(partialTick), 1.0F, 0.0F, 0.0F);
-            glRotatef(45f + 45F * ((ScreenPhotoMode) this.mc.currentScreen).getRotation(partialTick), 0.0F, 1.0F, 0.0F);
-        }
-    }
-
     public @NotNull Matrix4f orientCamera(@NotNull Matrix4f matrix, float partialTick) {
         setupCamera(partialTick);
 
         if (!(this.mc.currentScreen instanceof ScreenPhotoMode) && !this.mc.gameSettings.lockCamera.value) {
-            matrix.rotate(org.joml.Math.toRadians((float) this.mc.activeCamera.getXRot(partialTick)), 1.0F, 0.0F, 0.0F);
-            matrix.rotate(org.joml.Math.toRadians((float) (this.mc.activeCamera.getYRot(partialTick) + 180F)), 0.0F, 1.0F, 0.0F);
+            matrix.rotateX(org.joml.Math.toRadians((float) this.mc.activeCamera.getXRot(partialTick)));
+            matrix.rotateY(org.joml.Math.toRadians((float) (this.mc.activeCamera.getYRot(partialTick) + 180F)));
         }
 
         if (this.mc.currentScreen instanceof ScreenPhotoMode screenPhotoMode) {
-            matrix.rotate(org.joml.Math.toRadians(screenPhotoMode.getTilt(partialTick)), 1.0F, 0.0F, 0.0F);
-            matrix.rotate(org.joml.Math.toRadians(45f + 45F * screenPhotoMode.getRotation(partialTick)), 0.0F, 1.0F, 0.0F);
+            matrix.rotateX(org.joml.Math.toRadians(screenPhotoMode.getTilt(partialTick)));
+            matrix.rotateY(org.joml.Math.toRadians(45f + 45F * screenPhotoMode.getRotation(partialTick)));
         }
         return matrix;
     }
 
-    @Deprecated
-    private void setupCameraTransform(final float partialTicks) {
-        this.farPlaneDistance = this.mc.gameSettings.renderDistance.value * 16;
-        glMatrixMode(GL_PROJECTION);
-        glLoadIdentity();
-        float fov = getFOVModifier(partialTicks, true);
-        if (this.zooming) {
-            fov = getZoomedFOV(fov, partialTicks);
-        } else {
-            this.zoomProgress = 0;
-        }
-        if (this.mc.currentScreen instanceof ScreenPhotoMode) {
-            final double div = java.lang.Math.pow(2, ((ScreenPhotoMode) this.mc.currentScreen).getZoom(partialTicks));
-            glTranslatef(1, 1, 0);
-            glOrtho(0, this.mc.gameWindow.getWidthPixels() / div, 0, this.mc.gameWindow.getHeightPixels() / div, this.farPlaneDistance * -2.0f, this.farPlaneDistance * 2.0f);
-            glTranslatef(((ScreenPhotoMode) this.mc.currentScreen).getPanX(partialTicks), -((ScreenPhotoMode) this.mc.currentScreen).getPanY(partialTicks), 0);
-        } else {
-            GLU.gluPerspective(fov, (float) this.mc.gameWindow.getWidthPixels() / (float) this.mc.gameWindow.getHeightPixels(), 0.05F, this.farPlaneDistance * 2.0F);
-        }
-        glMatrixMode(GL_MODELVIEW);
-        glLoadIdentity();
-        hurtCameraEffect(partialTicks);
-        if (this.mc.gameSettings.viewBobbing.value && !(this.mc.currentScreen instanceof ScreenPhotoMode)) {
-            setupViewBobbing(partialTicks, false);
-        }
-        final float portalIntensity = this.mc.gameSettings.screenMotionEffects.value ? MathHelper.lerp(this.mc.thePlayer.prevTimeInPortal, this.mc.thePlayer.timeInPortal, partialTicks) : 0f;
-        if (portalIntensity > 0.0F) {
-            float f3 = 5F / (portalIntensity * portalIntensity + 5F) - portalIntensity * 0.04F;
-            f3 *= f3;
-            glRotatef(((float) this.rendererUpdateCount + partialTicks) * 20F, 0.0F, 1.0F, 1.0F);
-            glScalef(1.0F / f3, 1.0F, 1.0F);
-            glRotatef(-((float) this.rendererUpdateCount + partialTicks) * 20F, 0.0F, 1.0F, 1.0F);
-        }
-        orientCamera(partialTicks);
-    }
-
     public @NotNull Matrix4f getProjectionMatrix(@NotNull Matrix4f matrix, float partialTick) {
+        matrix.identity();
         this.farPlaneDistance = this.mc.gameSettings.renderDistance.value * 16;
         float fov = getFOVModifier(partialTick, true);
         if (this.zooming) {
@@ -428,8 +338,9 @@ public class WorldRenderer {
     }
 
     private void renderHand(float partialTick) {
-        glMatrixMode(GL_PROJECTION);
-        glLoadIdentity();
+        Matrix4f projMat = GLRenderer.projectionM4f();
+        projMat.identity();
+        this.farPlaneDistance = this.mc.gameSettings.renderDistance.value * 16;
         float fov = getFOVModifier(partialTick, false);
         if (this.zooming) {
             fov = getZoomedFOV(fov, partialTick);
@@ -437,34 +348,37 @@ public class WorldRenderer {
             this.zoomProgress = 0;
         }
         // Fix hand being rendered inside of blocks / behind rain
-        glTranslatef(0.0f, 0.0f, -1.0f);
-        glScalef(1.0f, 1.0f, 0.1f);
+        projMat.translate(0.0f, 0.0f, -1.0f);
+        projMat.scale(1.0f, 1.0f, 0.1f);
+
+        projMat.perspective(org.joml.Math.toRadians(fov), (float) this.mc.gameWindow.getWidthPixels() / (float) this.mc.gameWindow.getHeightPixels(), 0.05F, this.farPlaneDistance * 2.0F);
+
+        Matrix4f viewMat = GLRenderer.viewM4f();
+        viewMat.identity();
 
-        GLU.gluPerspective(fov, (float) this.mc.gameWindow.getWidthPixels() / (float) this.mc.gameWindow.getHeightPixels(), 0.05F, this.farPlaneDistance * 2.0F);
-        glMatrixMode(GL_MODELVIEW);
-        glLoadIdentity();
+        GLRenderer.modelM4f().identity();
 
-        glPushMatrix();
-        hurtCameraEffect(partialTick);
+        GLRenderer.pushFrame();
+        hurtCameraEffect(viewMat, partialTick);
         if (this.mc.gameSettings.viewBobbing.value) {
-            setupViewBobbing(partialTick, true);
+            setupViewBobbing(viewMat, partialTick, true);
         }
         if (this.mc.gameSettings.thirdPersonView.value == 0 && !(this.mc.currentScreen instanceof ScreenPhotoMode) && !(!(this.mc.activeCamera instanceof EntityCamera) || ((EntityCamera) this.mc.activeCamera).mob.isPlayerSleeping()) && this.mc.gameSettings.immersiveMode.drawHand()) {
             this.lightmapHelper.enableLightmapRendering();
             if (!this.zooming) this.itemRenderer.renderItemInFirstPerson(partialTick);
             this.lightmapHelper.disableLightmapRendering();
         }
-        glPopMatrix();
+        GLRenderer.popFrame();
 
         Debug.change("post");
         this.mc.renderer.endRenderWorld(partialTick);
 
         if (this.mc.gameSettings.thirdPersonView.value == 0 && !(!(this.mc.activeCamera instanceof EntityCamera) || ((EntityCamera) this.mc.activeCamera).mob.isPlayerSleeping())) {
             this.itemRenderer.renderOverlays(partialTick);
-            hurtCameraEffect(partialTick);
+            hurtCameraEffect(viewMat, partialTick);
         }
         if (this.mc.gameSettings.viewBobbing.value) {
-            setupViewBobbing(partialTick, false);
+            setupViewBobbing(viewMat, partialTick, false);
         }
     }
 
@@ -570,7 +484,7 @@ public class WorldRenderer {
             c = this.mc.gameSettings.customFpsLimit.value;
         }
         if (c <= 0) c = 1;
-        glViewport(0, 0, this.mc.gameWindow.getWidthPixels(), this.mc.gameWindow.getHeightPixels());
+        GL41.glViewport(0, 0, this.mc.gameWindow.getWidthPixels(), this.mc.gameWindow.getHeightPixels());
         if (this.mc.currentWorld != null) {
             Debug.change("world");
             if (!this.mc.gameSettings.enableVsync.value && this.mc.gameSettings.customFpsLimit.value == 0) // Max FPS
@@ -601,10 +515,9 @@ public class WorldRenderer {
             this.mc.hudIngame.renderGameOverlay(partialTick, this.mc.currentScreen != null, mouseX, mouseY);
             Debug.change("misc");
         } else {
-            glMatrixMode(GL_PROJECTION);
-            glLoadIdentity();
-            glMatrixMode(GL_MODELVIEW);
-            glLoadIdentity();
+            GLRenderer.projectionM4f().identity();
+            GLRenderer.viewM4f().identity();
+            GLRenderer.modelM4f().identity();
             setupScaledResolution();
             if (this.mc.gameSettings.enableVsync.value || this.mc.gameSettings.customFpsLimit.value > 0) {
                 Debug.change("sleep");
@@ -628,8 +541,14 @@ public class WorldRenderer {
         this.mc.guiToasts.render(partialTick);
 
         if (this.mc.currentScreen != null) {
+            GLRenderer.pushFrame();
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+            GLRenderer.enableState(State.DEPTH_TEST);
+            GLRenderer.setDepthFunc(CompareFunc.LESS_EQUAL);
+
             Debug.change("gui");
-            glClear(256);
+            GL41.glClear(GL41.GL_DEPTH_BUFFER_BIT);
             if (this.mc.inputType == InputType.CONTROLLER) {
                 mouseX = (int) this.mc.controllerInput.cursorX;
                 mouseY = (int) this.mc.controllerInput.cursorY;
@@ -650,28 +569,27 @@ public class WorldRenderer {
                 this.mc.currentScreen.drawControllerCursor();
             }
             Debug.change("misc");
+            GLRenderer.popFrame();
         }
     }
 
     public void renderWorld(float partialTicks, long updateRenderersUntil) {
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.WORLD);
         Debug.push("misc");
         Colorizers.update(false);
 
         RenderGlobal renderGlobal = this.mc.renderGlobal;
         ParticleEngine particleEngine = this.mc.particleEngine;
 
-        glEnable(GL_CULL_FACE);
-        glEnable(GL_DEPTH_TEST);
+        GLRenderer.enableState(State.CULL_FACE);
+        GLRenderer.enableState(State.DEPTH_TEST);
         if (this.mc.activeCamera == null) {
             this.mc.activeCamera = new EntityCameraFirstPerson(this.mc, this.mc.thePlayer);
         }
         getMouseOver(partialTicks);
-        Mob activeEntity = null;
-        if (this.mc.activeCamera instanceof EntityCamera) {
-            activeEntity = ((EntityCamera) this.mc.activeCamera).mob;
-        }
-
-        if (activeEntity != null) {
+        if (this.mc.activeCamera instanceof EntityCamera camera) {
+            Mob activeEntity = camera.mob;
             double viewEntityX = activeEntity.xo + (activeEntity.x - activeEntity.xo) * (double) partialTicks;
             double viewEntityZ = activeEntity.zo + (activeEntity.z - activeEntity.zo) * (double) partialTicks;
             IChunkProvider iChunkProvider = this.mc.currentWorld.getChunkProvider();
@@ -684,24 +602,19 @@ public class WorldRenderer {
 
         Debug.change("post");
         this.mc.renderer.beginRenderWorld(partialTicks);
-        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
-        glEnable(GL_CULL_FACE);
-        setupCameraTransform((this.mc.activeCamera instanceof EntityCamera && ((EntityCamera) this.mc.activeCamera).mob.isRemoved()) ? 1f : partialTicks);
-        Frustum.getFrustum();
+        GL41.glClear(GL41.GL_COLOR_BUFFER_BIT | GL41.GL_DEPTH_BUFFER_BIT);
+        GLRenderer.enableState(State.CULL_FACE);
+        float pt = (this.mc.activeCamera instanceof EntityCamera entityCamera && entityCamera.mob.isRemoved()) ? 1f : partialTicks;
+        getProjectionMatrix(GLRenderer.projectionM4f(), pt);
+        getViewMatrix(GLRenderer.viewM4f(), pt);
+        CameraFrustum.recalcFrustrum();
         Debug.change("sky");
-        if ((this.mc.gameSettings.renderDistance.value > 4) /* Used to use Renderdistance rendersky! */ && !(this.mc.currentScreen instanceof ScreenModelViewer)) {
-            this.fogManager.setupFog(FogManager.FOG_MODE_SKY, this.farPlaneDistance, partialTicks);
-            glDisable(GL_FOG);
-
+        if ((this.mc.gameSettings.renderDistance.value > 4) && !(this.mc.currentScreen instanceof ScreenModelViewer)) {
             renderGlobal.renderSky(partialTicks);
         }
 
         Debug.change("misc");
-        glEnable(GL_FOG);
-        this.fogManager.setupFog(FogManager.FOG_MODE_NORMAL, this.farPlaneDistance, partialTicks);
-        if (this.mc.gameSettings.ambientOcclusion.value) {
-            glShadeModel(GL11.GL_SMOOTH);
-        }
+        this.fogManager.setupFog(FogManager.FOG_MODE_NORMAL, this.farPlaneDistance, partialTicks, GLRenderer.getFogState());
 
         this.mc.renderGlobal.cull(this.mc.activeCamera.getFrustum(), partialTicks);
 
@@ -725,46 +638,42 @@ public class WorldRenderer {
             } while (timeRemaining >= 0L && timeRemaining <= nsPerSecond);
         }
 
-        this.fogManager.setupFog(FogManager.FOG_MODE_NORMAL, this.farPlaneDistance, partialTicks);
-        glEnable(GL_FOG);
-        TextureRegistry.blockAtlas.bind();
+        this.fogManager.setupFog(FogManager.FOG_MODE_NORMAL, this.farPlaneDistance, partialTicks, GLRenderer.getFogState());
+        TextureRegistry.worldAtlas.bind();
         Lighting.disable();
 
         Debug.change("terrain");
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.WORLD);
+        GLRenderer.globalSetUniforms(Shaders.WORLD);
         this.lightmapHelper.enableLightmapRendering();
         this.mc.terrainRenderer.renderSolidTerrain(partialTicks);
+        GLRenderer.popFrame();
 
         Debug.change("entities");
-        glShadeModel(GL_FLAT);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         Lighting.enableLight();
-        if (!this.mc.gameSettings.fog.value) {
-            glDisable(GL_FOG);
-        }
         renderGlobal.renderEntities(this.mc.activeCamera, partialTicks);
-        if (!this.mc.gameSettings.fog.value) {
-            glEnable(GL_FOG);
-        }
 
         Debug.change("particles");
-        glDisable(GL_BLEND);
+        GLRenderer.disableState(State.BLEND);
         particleEngine.renderLitParticles(this.mc.activeCamera, partialTicks);
         Lighting.disable();
-        this.fogManager.setupFog(FogManager.FOG_MODE_NORMAL, this.farPlaneDistance, partialTicks);
+        this.fogManager.setupFog(FogManager.FOG_MODE_NORMAL, this.farPlaneDistance, partialTicks, GLRenderer.getFogState());
         this.mc.renderer.beginRenderParticles(partialTicks);
-        particleEngine.renderParticles(this.mc.renderer.getParticleTessellator(), this.mc.activeCamera, partialTicks);
+        particleEngine.renderParticles(this.mc.activeCamera, partialTicks);
         this.mc.renderer.endRenderParticles(partialTicks);
 
         this.lightmapHelper.disableLightmapRendering();
 
         Debug.change("outline");
         if (this.mc.objectMouseOver != null) {
-            glDisable(GL_ALPHA_TEST);
+//            glDisable(GL_ALPHA_TEST);
             if (this.mc.objectMouseOver instanceof HitResult.Tile hitTile) {
                 renderGlobal.drawBlockBreaking(this.mc.activeCamera, hitTile, partialTicks);
             }
             renderGlobal.drawSelectionBox(this.mc.activeCamera, this.mc.objectMouseOver, partialTicks);
-            glEnable(GL_ALPHA_TEST);
+//            glEnable(GL_ALPHA_TEST);
         }
 
         Debug.change("debugoverlays");
@@ -774,52 +683,46 @@ public class WorldRenderer {
         if (this.mc.gameSettings.showChunkBorders.value) {
             renderGlobal.drawDebugChunkBorders(this.mc.activeCamera, partialTicks);
         }
-        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-        this.fogManager.setupFog(FogManager.FOG_MODE_NORMAL, this.farPlaneDistance, partialTicks);
-        glEnable(GL_BLEND);
-        glDisable(GL_CULL_FACE);
-        TextureRegistry.blockAtlas.bind();
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        this.fogManager.setupFog(FogManager.FOG_MODE_NORMAL, this.farPlaneDistance, partialTicks, GLRenderer.getFogState());
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.enableState(State.CULL_FACE);
+        TextureRegistry.worldAtlas.bind();
 
         Debug.change("water");
         this.lightmapHelper.enableLightmapRendering();
-        if (this.mc.gameSettings.ambientOcclusion.value) {
-            glShadeModel(GL_SMOOTH);
-        }
-        if (!this.mc.gameSettings.fog.value) {
-            glDisable(GL_FOG);
-        }
+        GLRenderer.pushFrame();
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.disableState(State.CULL_FACE);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.setShader(Shaders.WORLD);
+        GLRenderer.globalSetUniforms(Shaders.WORLD);
         this.mc.terrainRenderer.renderTranslucentTerrain(partialTicks);
-        if (!this.mc.gameSettings.fog.value) {
-            glEnable(GL_FOG);
-        }
-        glShadeModel(GL_FLAT);
+        GLRenderer.popFrame();
         this.lightmapHelper.disableLightmapRendering();
 
         Debug.change("weather");
-        glDepthMask(true);
-        glEnable(GL_CULL_FACE);
-        glDisable(GL_BLEND);
+        GLRenderer.setDepthMask(true);
+        GLRenderer.enableState(State.CULL_FACE);
+        GLRenderer.disableState(State.BLEND);
         renderRainSnow(partialTicks);
-        glDisable(GL_FOG);
         if (this.mc.gameSettings.clouds.value) {
             Debug.change("clouds");
-            this.fogManager.setupFog(FogManager.FOG_MODE_NORMAL, this.farPlaneDistance, partialTicks);
-            glEnable(GL_FOG);
+            this.fogManager.setupFog(FogManager.FOG_MODE_SKY, this.farPlaneDistance, partialTicks, GLRenderer.getFogState());
             renderGlobal.renderClouds(partialTicks);
-            glDisable(GL_FOG);
         }
 
         Debug.change("misc");
-        this.fogManager.setupFog(1, this.farPlaneDistance, partialTicks);
-        renderHand((this.mc.activeCamera instanceof EntityCamera && ((EntityCamera) this.mc.activeCamera).mob.isRemoved()) ? 1f : partialTicks);
+        this.fogManager.setupFog(1, this.farPlaneDistance, partialTicks, GLRenderer.getFogState());
+        renderHand((this.mc.activeCamera instanceof EntityCamera camera && camera.mob.isRemoved()) ? 1f : partialTicks);
 
-        glColorMask(true, true, true, true);
         Debug.pop();
+        GLRenderer.popFrame();
     }
 
     private void addRainParticles() {
         Weather weather = this.mc.currentWorld.getCurrentWeather();
-        if (!(weather instanceof IPrecipitation) || !((IPrecipitation) weather).spawnRainParticles()) return;
+        if (!(weather instanceof IPrecipitation precipitation) || !precipitation.spawnRainParticles()) return;
 
         float f = this.mc.currentWorld.weatherManager.getWeatherIntensity() * this.mc.currentWorld.weatherManager.getWeatherPower();
 
@@ -889,12 +792,15 @@ public class WorldRenderer {
         int posX = MathHelper.floor(this.mc.activeCamera.getX());
         int posY = MathHelper.floor(this.mc.activeCamera.getY());
         int posZ = MathHelper.floor(this.mc.activeCamera.getZ());
-        Tessellator tessellator = Tessellator.instance;
-        glDisable(GL11.GL_CULL_FACE);
-        glNormal3f(0.0F, 1.0F, 0.0F);
-        glEnable(GL11.GL_BLEND);
-        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-        glAlphaFunc(516, 0.01F);
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.WORLD);
+        GLRenderer.setLightmapCoord2i(15, 15);
+        GLRenderer.disableState(State.CULL_FACE);
+//        glNormal3f(0.0F, 1.0F, 0.0F);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+//        glAlphaFunc(516, 0.01F);
 
         this.mc.textureManager.loadTexture(precipitation.getPrecipitationTexturePath(world.weatherManager.getWeatherPower(), world.weatherManager.getWeatherIntensity())).bind();
 
@@ -904,7 +810,10 @@ public class WorldRenderer {
         int floorPosY = MathHelper.floor(nextPosY);
         int radiusEffect = 10;
 
+        TilePos queryPos = new TilePos();
+
         if (precipitation.getPrecipitationType() == IPrecipitation.Type.SNOW_LIKE) {
+            tessellator.startDrawingQuads();
             for (int x = posX - radiusEffect; x <= posX + radiusEffect; x++) {
                 blockedWeather:
                 for (int z = posZ - radiusEffect; z <= posZ + radiusEffect; z++) {
